/*
 * SSD1351_driver.inc
 *
 *  Created: 02.11.2020 23:16:35
 *   Author: N0082
 */ 

.equ	SPI0_CS_VPORT					= VPORTA
;.equ	SPI0_CS							= PA4
.equ	SSD1351_RST_VPORT				= VPORTA
.equ	SSD1351_RST						= PA5
.equ	SSD1351_DC_VPORT				= VPORTA
.equ	SSD1351_DC						= PA6


 /*
 ; OLED Display settings
.equ	Display_Xsize					= 128	// in Pixel	(DOT's)	[1..320]
.equ	Display_Ysize					= 128	// in Pixel (DOT's)	[1..256]
;.equ	Character_Xsize					= 6		// in Pixel (DOT's) [1..8]

;.equ	Page_Ysize						= 8		// in Pixel (DOT's) [1..8]

#define	OLED_DISPLAY_ANGEL				90		// 0 , 90 , 180 , 270 degree
*/


.equ	SSD1351_CMD_SETCOLUMN			= 0x15
.equ	SSD1351_CMD_SETROW				= 0x75
.equ	SSD1351_CMD_WRITERAM			= 0x5C
.equ	SSD1351_CMD_READRAM				= 0x5D
.equ	SSD1351_CMD_SETREMAP			= 0xA0
.equ	SSD1351_CMD_STARTLINE			= 0xA1
.equ	SSD1351_CMD_DISPLAYOFFSET		= 0xA2
.equ	SSD1351_CMD_DISPLAYALLOFF		= 0xA4
.equ	SSD1351_CMD_DISPLAYALLON		= 0xA5
.equ	SSD1351_CMD_NORMALDISPLAY		= 0xA6
.equ	SSD1351_CMD_INVERTDISPLAY		= 0xA7
.equ	SSD1351_CMD_FUNCTIONSELECT		= 0xAB
.equ	SSD1351_CMD_DISPLAYOFF			= 0xAE
.equ	SSD1351_CMD_DISPLAYON			= 0xAF
.equ	SSD1351_CMD_PRECHARGE			= 0xB1
.equ	SSD1351_CMD_DISPLAYENHANCE		= 0xB2
.equ	SSD1351_CMD_CLOCKDIV			= 0xB3
.equ	SSD1351_CMD_SETVSL				= 0xB4
.equ	SSD1351_CMD_SETGPIO 		    = 0xB5
.equ	SSD1351_CMD_PRECHARGE2			= 0xB6
.equ	SSD1351_CMD_SETGRAY				= 0xB8
.equ	SSD1351_CMD_USELUT				= 0xB9
.equ	SSD1351_CMD_PRECHARGELEVEL		= 0xBB
.equ	SSD1351_CMD_VCOMH				= 0xBE
.equ	SSD1351_CMD_CONTRASTABC			= 0xC1
.equ	SSD1351_CMD_CONTRASTMASTER		= 0xC7
.equ	SSD1351_CMD_MUXRATIO			= 0xCA
.equ	SSD1351_CMD_COMMANDLOCK			= 0xFD
.equ	SSD1351_CMD_HORIZSCROLL			= 0x96
.equ	SSD1351_CMD_STOPSCROLL			= 0x9E
.equ	SSD1351_CMD_STARTSCROLL			= 0x9F

#ifndef	OLED_DISPLAY_ANGEL
#define	OLED_DISPLAY_ANGEL
#endif

.equ	BLUE_bp			= 0
.equ	GREEN_bp		= 5
.equ	RED_bp			= 11
.equ	BLACK			= 0x0000
.equ	BLUE			= 0x001F
.equ	RED				= 0xF800
.equ	GREEN			= 0x07E0
.equ	CYAN			= 0x07FF
.equ	MAGENTA			= 0xF81F
.equ	YELLOW			= 0xFFE0
.equ	WHITE			= 0xFFFF


// oled_init()
// oled_home()
// oled_set_xy(x,y)							(XL = x	// YL = y)
// oled_clr_screen()
// oled_draw_pixel(x,y,color)					(XL = x // YL = y // r17:r16 = color)

// DISPLAY GFX
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// oled_fill_screen(color)						(r17:r16 = 16bit Color)
// oled_clr_window(xs,ys,xe,ye)					(XL = Xstart // YL = Ystart // XH = Xend // YH = Yend)
// oled_fill_window(xs,ys,xe,ye,color)			(XL = Xstart // YL = Ystart // XH = Xend // YH = Yend // r17:r16 = color)
// oled_draw_hline(xs,ys,xw,color)				(XL = Xstart // YL = Ystart // XH = widht // r17:r16 = COLOR)
// oled_draw_vline(xs,ys,yw,color)				(XL = Xstart // YL = Ystart // YH = widht // r17:r16 = COLOR)
// oled_draw_line(xs,ys,xe,ye,color)			(XL = Xstart // YL = Ystart // XH = Xend // YH = Yend // r17:r16 = color)
// oled_draw_circle(xc,yc,r,color)				(XL = Xcenter // YL = Ycenter // XH = Radius // r17:r16 = color)
// oled_draw_fill_circle(xc,yc,r,color)			(XL = Xcenter // YL = Ycenter // XH = Radius // r17:r16 = color)
// oled_draw_fill_rect(xs,ys,xw,yw,color)		(XL = Xstart // YL = Ystart // XH = widht // YH = hight // r17:r16 = COLOR)
// oled_draw_round_rect(xs,ys,xw,yw,r,color)	(XL = Xstart // YL = Ystart // XH = widht // YH = hight // r18 = Radius // r17:r16 = COLOR)

//#define	 use_fill_screen						
//#define	 use_clr_window
//#define	 use_fill_window
//#define	 use_draw_hline
//#define	 use_draw_vline
//#define	 use_draw_line
//#define	 use_draw_circle
#define	 use_draw_fill_circle
#define	 use_draw_rect
//#define	 use_draw_fill_rect
#define	 use_draw_round_rect
#define	 use_draw_fill_round_rect


oled_init:

#if		OLED_DISPLAY_ANGEL == 0
#warning	"OLED_DISPLAY_ANGEL = 0 deg"
		ldi		r16,(1<<0)										;  -> orientation 0 degree
#elif	OLED_DISPLAY_ANGEL == 90
#warning	"OLED_DISPLAY_ANGEL = 90 deg"
		ldi		r16,(1<<1)										;  -> orientation 90 degree
#elif	OLED_DISPLAY_ANGEL == 180
#warning	"OLED_DISPLAY_ANGEL = 180 deg"
		ldi		r16,(1<<2)										;  -> orientation 180 degree
#elif	OLED_DISPLAY_ANGEL == 270
#warning	"OLED_DISPLAY_ANGEL = 270 deg"
		ldi		r16,(1<<4)										;  -> orientation 270 degree
#else
#undef	OLED_DISPLAY_ANGEL
#define	OLED_DISPLAY_ANGEL	0
#warning	"WRONG DISPLAY ORIANTATION !!!"
#warning	"Set OLED_DISPLAY_ANGEL to 0 deg"
		ldi		r16,(1<<0)										; write DATA (0x66) -> orientation 0 degree
#endif


		sts		(ORIANTATION),r16
		sbi		((SSD1351_RST_VPORT)+0),(SSD1351_RST)			; VPORT.DIR
		sbi		((SSD1351_DC_VPORT)+0),(SSD1351_DC)				; VPORT.DIR
		sbi		((SSD1351_RST_VPORT)+1),(SSD1351_RST)			; VPORT.OUT
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
		delay	(50)
		cbi		((SSD1351_RST_VPORT)+1),(SSD1351_RST)			; VPORT.OUT
		delay	(500)
		sbi		((SSD1351_RST_VPORT)+1),(SSD1351_RST)			; VPORT.OUT
		delay	(500)
		cbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 0		--> SPI DEVICE SELECTED
;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_COMMANDLOCK)					; write COMMAND 
		sts		(SPI0_DATA),r16									; "LOCK"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0x12)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x12)
		;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_COMMANDLOCK)					; write COMMAND 
		sts		(SPI0_DATA),r16									; "LOCK"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0xB1)										; write DATA 
		sts		(SPI0_DATA),r16									; (0xB1)
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_DISPLAYOFF)					;  write COMMAND 
		sts		(SPI0_DATA),r16									; "DISPLAY OFF"
;SPI write Command
		ldi		r16,(SSD1351_CMD_DISPLAYALLOFF)					;  write COMMAND 
		sts		(SPI0_DATA),r16									; "NORMAL DISPLAY ALL OFF"
;SPI write Command
;wait spi->DRE data register emty
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_DREIF_bp)
		rjmp	PC -3
		ldi		r16,(SSD1351_CMD_SETCOLUMN)						;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET COLUMN ADDRESS"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0x00)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x00)	Start Address
;SPI write Data
		ldi		r16,((Display_Xsize)-1)							; write DATA 
		sts		(SPI0_DATA),r16									; (0x7F)	End Address
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_SETROW)						;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET ROW ADDRESS"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0x00)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x00)	Start Address
;SPI write Data
		ldi		r16,((Display_Ysize)-1)							; write DATA 
		sts		(SPI0_DATA),r16									; (0x7F)	End Address
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_CLOCKDIV)						;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET CLOCK DIV"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0xF1)										; write DATA 
		sts		(SPI0_DATA),r16									; (0xF1) or faster fFRAM by(0xF0)
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_MUXRATIO)						;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET MUX RATIO"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0x7F)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x7F)
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_SETREMAP)						;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET REMAP & DATA FORMAT"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)

		lds		r0,(ORIANTATION)
		sbrc	r0,0											; Oriantation = 0 deg
		ldi		r16,(0x65)
		sbrc	r0,1											; Oriantation = 90 deg
		ldi		r16,(0x66)
		sbrc	r0,2											; Oriantation = 180 deg
		ldi		r16,(0x77)
		sbrc	r0,3											; Oriantation = 270 deg
		ldi		r16,(0x74)
/*
#if		OLED_DISPLAY_ANGEL == 0
#warning	"OLED_DISPLAY_ANGEL = 0 deg"
		ldi		r16,(0x65)										; write DATA (0x66) -> orientation 0 degree
#elif	OLED_DISPLAY_ANGEL == 90
#warning	"OLED_DISPLAY_ANGEL = 90 deg"
		ldi		r16,(0x66)										; write DATA (0x66) -> orientation 180 degree
#elif	OLED_DISPLAY_ANGEL == 180
#warning	"OLED_DISPLAY_ANGEL = 180 deg"
		ldi		r16,(0x77)										; write DATA (0x66) -> orientation 180 degree
#elif	OLED_DISPLAY_ANGEL == 270
#warning	"OLED_DISPLAY_ANGEL = 270 deg"
		ldi		r16,(0x74)										; write DATA (0x66) -> orientation 180 degree
#else
#undef	OLED_DISPLAY_ANGEL
#define	OLED_DISPLAY_ANGEL	0
#warning	"WRONG DISPLAY ORIANTATION !!!"
#warning	"Set OLED_DISPLAY_ANGEL to 0 deg"
		ldi		r16,(0x65)										; write DATA (0x66) -> orientation 0 degree
#endif
*/

;SPI write Data
		sts		(SPI0_DATA),r16									; 
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_STARTLINE)						;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET DISPLAY START LINE"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0x00)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x00)
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_DISPLAYOFFSET)					;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET DISPLAY OFFSET"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0x00)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x00)
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_FUNCTIONSELECT)				;  write COMMAND 
		sts		(SPI0_DATA),r16									; "FUNCTIONS SELECTION"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
;		ldi		r16,(0x00)										; write DATA (0x00) --> 8-bit Interface [reset]
		ldi		r16,(0x01)										; write DATA (0x01) --> 16-bit Interface
;		ldi		r16,(0x03)										; write DATA (0x03) --> 18-bit Interface
		sts		(SPI0_DATA),r16									; 
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_SETVSL)						;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET SEGMENT LOW VOLTAGE"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0xA0)										; write DATA 
		sts		(SPI0_DATA),r16									; A (0xA0)
;SPI write Data
		ldi		r16,(0xB5)										; write DATA 
		sts		(SPI0_DATA),r16									; B (0xB5)
;SPI write Data
;wait spi->DRE data register emty
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_DREIF_bp)
		rjmp	PC -3
		ldi		r16,(0x55)										; write DATA 
		sts		(SPI0_DATA),r16									; C (0x55)
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_CONTRASTABC)					;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET CONTRAST VALUE FOR EACH PIXEL COLOR"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(200)										; write DATA 
		sts		(SPI0_DATA),r16									; COLOR A (0xC8)		BLUE	200		(138) -> reset
;SPI write Data
		ldi		r16,(60)										; write DATA 
		sts		(SPI0_DATA),r16									; COLOR B (0x80)		GREEN	128		(81) -> reset
;SPI write Data
;wait spi->DRE data register emty
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_DREIF_bp)
		rjmp	PC -3
		ldi		r16,(100)										; write DATA 
		sts		(SPI0_DATA),r16									; COLOR C (0xC0)		RED		192		(138) -> reset
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_CONTRASTMASTER)				;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET MASTER CONTRAST"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(15)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x0F) full power (15)
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_PRECHARGE)						;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET PRECHARGE PHASE"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0x32)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x32) Phase2= 3 DCLK	| Phase1= 5 DCLK
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_DISPLAYENHANCE)				;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET DISPLAY ENHANCE"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0xA4)										; write DATA 
		sts		(SPI0_DATA),r16									; (0xA4)	enhance display performance
;SPI write Data
		ldi		r16,(0x00)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x00)
;SPI write Data
;wait spi->DRE data register emty
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_DREIF_bp)
		rjmp	PC -3
		ldi		r16,(0x00)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x00)
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_PRECHARGELEVEL)				;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET PRE CHARGE LEVEL"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0x17)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x17) [reset] --> (23 x 0.0125V) + 0.200V = 0.4875V x Vcc
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_PRECHARGE2)					;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET SECOND PRE CHARGE PERIOD"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(0x01)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x01) --> 1 DCLK
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_VCOMH)							;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET VCOMH VOLTAGE"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
		ldi		r16,(5)										; write DATA 
		sts		(SPI0_DATA),r16									; (0x05) [reset] --> 0.82 x Vcc [0..7] (0.72..0.86)
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_NORMALDISPLAY)					;  write COMMAND 
;		ldi		r16,(SSD1351_CMD_INVERTDISPLAY)
		sts		(SPI0_DATA),r16									; "SET NORMAL DISPLAY MODE"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)

		rcall	oled_clr_screen
		cbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 0		--> SPI DEVICE SELECTED
;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r16,(SSD1351_CMD_DISPLAYON)						;  write COMMAND 
		sts		(SPI0_DATA),r16									; "SET DISPLAY ON"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
		sbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 0		--> SPI DEVICE SELECTED

		ldi		r16,(Display_Xsize)
		ldi		r17,(Display_Ysize)
		sts		(winXw),r16
		sts		(winYw),r17
		dec		r16
		dec		r17
		sts		(winXs),r16
		sts		(winYs),r17
		ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_home:
		clr		XL
		ldi		XH,((Display_Xsize)-1)
		clr		YL
		ldi		YH,((Display_Ysize)-1)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_set_xy:	; (Grafic Mode)		XL = Xstart	|	XH = Xend	|	YL = Ystart	|	YH = Yend				XL;XH;YL;YH -> [0..127] 
;SPI write Command
		mov		r1,r18
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r18,(SSD1351_CMD_SETCOLUMN)						;  write COMMAND 
		sts		(SPI0_DATA),r18									; "SET COLUMN ADDRESS"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
	
/*
#if		OLED_DISPLAY_ANGEL == 0	|| OLED_DISPLAY_ANGEL == 180
;SPI write Data									
		sts		(SPI0_DATA),YL									; write DATA Xpos Start
;SPI write Data					
		sts		(SPI0_DATA),YH									; write DATA Xpos End
#else
;SPI write Data									
		sts		(SPI0_DATA),XL									; write DATA Xpos Start
;SPI write Data					
		sts		(SPI0_DATA),XH									; write DATA Xpos End
#endif
*/

		lds		r0,(ORIANTATION)
		sbrc	r0,0
		rjmp	oled_set_xy_col_0_180
		sbrc	r0,2
		rjmp	oled_set_xy_col_0_180

oled_set_xy_col_90_270:
;SPI write Data									
		sts		(SPI0_DATA),XL									; write DATA Xpos Start
;SPI write Data					
		sts		(SPI0_DATA),XH									; write DATA Xpos End
		rjmp	oled_set_xy_wr_col

oled_set_xy_col_0_180:
;SPI write Data									
		sts		(SPI0_DATA),YL									; write DATA Xpos Start
;SPI write Data					
		sts		(SPI0_DATA),YH									; write DATA Xpos End
		rjmp	oled_set_xy_wr_col


oled_set_xy_wr_col:
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0

;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r18,(SSD1351_CMD_SETROW)						;  write COMMAND 
		sts		(SPI0_DATA),r18									; "SET COLUMN"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)

/*
#if		OLED_DISPLAY_ANGEL == 0	|| OLED_DISPLAY_ANGEL == 180
;SPI write Data									
		sts		(SPI0_DATA),XL									; write DATA Ypos Start
;SPI write Data							
		sts		(SPI0_DATA),XH									; write DATA Ypos End
#else
;SPI write Data									
		sts		(SPI0_DATA),YL									; write DATA Ypos Start
;SPI write Data							
		sts		(SPI0_DATA),YH									; write DATA Ypos End
#endif
*/
		lds		r0,(ORIANTATION)
		sbrc	r0,0
		rjmp	oled_set_xy_row_0_180
		sbrc	r0,2
		rjmp	oled_set_xy_row_0_180

oled_set_xy_row_90_270:
;SPI write Data									
		sts		(SPI0_DATA),YL									; write DATA Xpos Start
;SPI write Data					
		sts		(SPI0_DATA),YH									; write DATA Xpos End
		rjmp	oled_set_xy_wr_row

oled_set_xy_row_0_180:
;SPI write Data									
		sts		(SPI0_DATA),XL									; write DATA Xpos Start
;SPI write Data					
		sts		(SPI0_DATA),XH									; write DATA Xpos End
		rjmp	oled_set_xy_wr_row

oled_set_xy_wr_row:
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		mov		r18,r1
		ret	

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_clr_screen:
		clr		XL
		ldi		XH,((Display_Xsize)-1)
		clr		YL
		ldi		YH,((Display_Ysize)-1)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_clr_window:
		movw	r2,XL
		sub		r3,r2
		inc		r3
		mov		r4,r3				; r4 Xsize
		movw	r2,YL
		sub		r3,r2
		inc		r3
;		mov		r5,r3				; r3,r5 Ysize
oled_clr_window_start:
		cbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 0		--> SPI DEVICE SELECTED
		rcall	oled_set_xy
;SPI write Command
		mov		r1,r18
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		r18,(SSD1351_CMD_WRITERAM)						;  write COMMAND 
		sts		(SPI0_DATA),r18									; "WRITE DATA TO DRAM"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
oled_clr_screen_loop_i:
		mov		r5,r3
oled_clr_screen_loop_j:	
;SPI write Data									
		sts		(SPI0_DATA),ZERO								; write DATA PIX COLOR L
;SPI write Data									
		sts		(SPI0_DATA),ZERO								; write DATA PIX COLOR H
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		dec		r5
		brne	oled_clr_screen_loop_j
		dec		r4
		brne	oled_clr_screen_loop_i
		sbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 1		--> SPI DEVICE DESELECTED
		mov		r18,r1
		ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
oled_draw_pixel:			; XL = X	|	YL = Y	|	r17:r16 = COLOR
		cbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 0		--> SPI DEVICE SELECTED
		mov		XH,XL
		mov		YH,YL
		rcall	oled_set_xy
;SPI write Command
		cbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 0		--> (COMMAND)
		ldi		XH,(SSD1351_CMD_WRITERAM)						;  write COMMAND 
		sts		(SPI0_DATA),XH									; "WRITE DATA TO DRAM"
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SSD1351_DC_VPORT)+1),(SSD1351_DC)				; VPORT.OUT.DC = 1		--> (DATA)
;SPI write Data
#if	defined	USE_DELAY
	delay	6
#endif							
		sts		(SPI0_DATA),r17								; write DATA PIX COLOR H
;SPI write Data									
		sts		(SPI0_DATA),r16								; write DATA PIX COLOR L
;wait spi->TX->ready
		lds		r0,(SPI0_INTFLAGS)
		sbrs	r0,(SPI_TXCIF_bp)
		rjmp	PC -3
		sts		(SPI0_INTFLAGS),r0
		sbi		((SPI0_CS_VPORT)+1),(SPI0_CS)					; VPORT.OUT.CS = 1		--> SPI DEVICE DESELECTED
		ret



;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
oled_set_txt_color:
		sts		((txtCOLOR)+0),r16
		sts		((txtCOLOR)+1),r17
ret
oled_set_back_color:
		sts		((backCOLOR)+0),r16
		sts		((backCOLOR)+1),r17
ret
*/
